$headerItemPadding: 8px;
$hoverColor: #f4f5f5;
$selectedColor: #e9ebeb;
$messageBorderRadius: 7.5px;
$sendMessageElementSpace: 10px;
$iconWrapperBorderRadius: 50%;
$messageTailSize: 7px;
$messageExtraWidth: 60px;
$boxShadowStandard: 0 2px 5px 0 rgba(0, 0, 0, 0.26), 0 2px 10px 0 rgba(0, 0, 0, 0.16);

:host {
  display: flex;
  flex: 1;
  justify-content: center;
  align-items: center;
}

.main {
  display: flex;
  width: 80%;
  height: 80%;
  min-width: 600px;
  min-height: 400px;
  //box-shadow: 2px 2px 13px 1px rgba(110, 110, 110, 0.21);
  border: 1px solid rgb(218, 220, 224);
  border-radius: 5px;
}





// group-wrapper
.groups-wrapper {
  flex: 1;
  display: flex;
  flex-direction: column;
}

.groups-list-item-link {
  color: inherit;
  text-decoration: none;

  &:not(:first-child) {
    >.groups-list-item {
      border-top: 1px solid #f2f2f2;
    }
  }
}

.groups-list-item {
  cursor: pointer;
  padding: 14px 16px;

  &:hover:not(.selected) {
    background-color: $hoverColor;
  }

  &.joined {
    //background: yellowgreen;

    &.selected {
      //background: lightgreen;
    }
  }

  &.selected {
    background-color: $selectedColor;
  }
}
// end group-wrapper





// data-wrapper
.data-wrapper {
  flex: 3;
  border-left: 1px solid #dadce0;
}

.data-wrapper-main {
  height: 100%;
  display: flex;
  flex-direction: column;
}

/* data-header is with a separate header group */

// data-message-list
.data-message-list {
  /* scroll to bottom automatically */
  display: flex;
  flex-direction: column-reverse;
  background: #e5ddd5;
}

$tailWidth: 16;
$tailHeight: $tailWidth;
$tailBorderRadius: 5;

.data-message-wrapper {
  margin: 10px 6%;
  display: flex;

  &.message-self {
    flex-direction: row-reverse;

    .data-message {
      border-top-right-radius: 0;
      border-top-left-radius: $messageBorderRadius;
    }

    .data-message-tail {
      transform: skewX(-45deg);
      left: -#{$tailWidth/2 + $tailBorderRadius}px;

      /*
      cut a triangle(A, B, C)
      extra space on (x-axis before B and on y-axis after C) is because of the border-radius,
      we don't want to include (top-left(before B) and bottom-right(after C)) border-radius in resulting triangle

      +---B----------A
      |              |
      |              |
      |              |
      |              C
      |              |
      +--------------+
      */
      clip-path: polygon(100% 0%, calc(0% + #{$tailBorderRadius}px) 0%, 100% calc(100% - #{$tailBorderRadius}px));
    }
  }
}

.data-message-tail {

  width: #{$tailWidth}px;
  height: #{$tailHeight}px;
  position: relative;
  left: #{$tailWidth/2 + $tailBorderRadius}px;
  border-radius: #{$tailBorderRadius}px;
  background: white;
  transform: skewX(45deg);

  /*
  cut a triangle(A, B, C)
  extra space on (x-axis after B and on y-axis after C) is because of the border-radius,
  we don't want to include (top-right(after B) and bottom-left(after C)) border-radius in resulting triangle

  A----------B---+
  |              |
  |              |
  |              |
  C              |
  |              |
  +--------------+
  */
  clip-path: polygon(0% 0%, calc(100% - #{$tailBorderRadius}px) 0%, 0% calc(100% - #{$tailBorderRadius}px));

  // you can get rid of the clip-path property if you use z-index,
  // in which case this tail will hide behind the actual message
  // z-index: 1;
}

.data-message {
  max-width: 75%;
  background: white;
  box-shadow: 0 1px 0.5px rgba(0,0,0,.13);
  padding: 6px 10px;
  display: flex;
  border-top-right-radius: $messageBorderRadius;
  border-bottom-right-radius: $messageBorderRadius;
  border-bottom-left-radius: $messageBorderRadius;

  // use higher value than z-index of tail
  // z-index: 2;
}

.data-message-from {
  font-size: 12.8px;
  font-weight: 500;
  line-height: 22px;
  color: #1f7aec;
}

.data-message-message {
  white-space: pre-wrap;
  word-break: break-word;
}

.data-message-fixed {
  width: $messageExtraWidth;
  display: flex;
  justify-content: flex-end;
  align-items: flex-end;
}

.data-message-time {
  font-size: 0.65em;
  color: grey;
}
// end data-message-list


// data-message-send
.data-message-send-wrapper {
  display: flex;
  align-items: center;
  padding: 10px;
  background: #f0f0f0;
}

.data-message-send-input-wrapper {
  flex: 1;
}

.data-message-send-input-outer {
  padding: 10px 15px;
  margin: 0 $sendMessageElementSpace;
  border-radius: 21px;
  background: white;
}

.data-message-send-input {
  /*font-size: 15px;*/
  /*font-weight: 400;*/
  max-height: 100px;
  min-height: 20px;
  overflow-x: hidden;
  overflow-y: auto;
  outline: none;
  white-space: pre-wrap;
  word-break: break-word;
}

.data-message-send-button {
  padding: $sendMessageElementSpace;
  border-radius: $iconWrapperBorderRadius;

  &:active {
    background-color: rgba(0, 0, 0, 0.1);
  }
}
// end data-message-send
// end data-wrapper





// common: group-wrapper + data-wrapper

.groups-wrapper, .data-wrapper {
  height: 100%;
}

.groups-list-wrapper, .data-message-list {
  flex-grow: 1;
  flex-basis: 0;
  overflow-x: hidden;
  overflow-y: auto;
}
// end common: group-wrapper + data-wrapper




// header
.header {
  display: flex;
  padding: 10px 16px;
  background-color: #f0f0f0;
  border-bottom: 1px solid #dadce0;
}

.header-item {
  display: flex;
  align-items: center;

  &:not(:first-child) {
    margin-left: 10px;
  }
}


// data header
.data-header {
  .header-name {
    font-size: 1.2em;
  }
}

.header-name {
  flex: 1;
}

.data-header-members {
  font-size: 0.8em;
}


// data-header-options
.header-options {
  position: relative;
  outline: none;

  /*
  prevent options-list from breaking into new line when parent div doesn't have enough width for both
  https://stackoverflow.com/questions/26331205/css-relative-positioning-breaks-div-into-new-line/26331227#26331227
  */
  white-space: nowrap;
}


// data-header-options-button
.header-options-button {
  padding: $headerItemPadding;
  border-radius: $iconWrapperBorderRadius;

  &.clicked {
    background-color: rgba(0, 0, 0, 0.1);
  }
}
// end data-header-options-button


// data-header-options-list
.header-options-list {
  position: absolute;
  right: 5px;
  margin-top: 3px;
  transform: scale(0);
  transform-origin: right top;
  transition: transform 0.1s;
  background: #fff;
  box-shadow: $boxShadowStandard;
  padding: 8px 0;
  border-radius: 3px;
  z-index: 10;

  &.show {
    transform: scale(1);
  }
}

.header-option-item {
  cursor: pointer;
  user-select: none;
  padding: 5px 20px;

  &:hover {
    background-color: $hoverColor;
  }
}
// end data-header-options-list
// end data-header-options
// end data-header
// end header



// helpers
.icon-wrapper {
  /* to prevent icon height overflow/extra space vertically */
  display: flex;
  cursor: pointer;
  user-select: none;
}

input {
  width: 100%;
}

.hidden {
  display: none;
}
//end helpers



.popup-wrapper {
  position: absolute;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
  background: rgba(110, 110, 110, 0.7);
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 100;
}

.popup {
  background: white;
  padding: 20px;
  border-radius: 5px;
  box-shadow: 0 2px 5px 0 rgba(0, 0, 0, 0.26), 0 2px 10px 0 rgba(0, 0, 0, 0.16);
}

.create-group-popup-input {
  width: 400px;
  max-width: 80vw;
}

.create-group-popup-button-wrapper {
  display: flex;
  justify-content: flex-end;
}

.create-group-popup-message {
  margin-bottom: 0;
  margin-top: 1rem;
}

















//.main {
//  background-color: lightgrey;
//  width: 100vw;
//  height: 100vh;
//
//  display: flex;
//  flex-direction: column;
//  justify-content: center;
//  align-items: center;
//}
//
//.parent {
//  width: 80%;
//  height: 80%;
//  border-right: 5px solid black;
//
//  display: flex;
//  flex-direction: column;
//}
//
//.child-1, .child-3 {
//  flex: 1;
//  background-color: white;
//}
//
//.child-2 {
//  flex: 5;
//  background-color: pink;
//  border-right: 5px solid orange;
//
//  /* why this solves the issue */
//  /* overflow: auto; */
//
//  display: flex;
//  flex-direction: column;
//}
//
//.grand-child-1 {
//  flex-grow: 1;
//
//  /* why changing this from 0% to 0 solves the issue */
//  flex-basis: 0%;
//
//  overflow: auto;
//  border-right: 5px solid red;
//  background-color: grey;
//}
//
//.grand-child-2 {
//  flex: 1;
//  background-color: skyblue;
//}
//
//.max-div {
//  height: 600px;
//  background-color: lightseagreen;
//}
